var largeur_jeu=800,hauteur_jeu=520,//Dimensions du tapis de jeu
	max_points=4,// valeur maximale d'une face
	nb_des=6,//Nombre de dés à lancer
	taille_de=60,// Dimension d'un dé (moitié d'un côté) -taille_de->taille_de
	pointX=taille_de/2,pointY=taille_de/2,// Coordonnées des points du dés
	taille_point=12,// Grosseur du point
	espace_de=10,// Escpace minimum entre 2 dés
	total=0;// Total des dés obtenus


	// Calcul de la place prise par 1 dé
	// En fonction de la taille du dé et de l'espace entre 2 dés
	// Afin qu'ils ne se touchent pas (bug affichage)
	var deltaX=taille_de*2.5+espace_de*2,deltaY=taille_de*2.5+espace_de*2;
	
	// Calcul du nombre de places possibles en fonction de la place occupée par 1 dé
	var nbpos=Math.floor(largeur_jeu/deltaX)*Math.floor(hauteur_jeu/deltaY);
    
	// Création d'un tableau à 2 dimensions avec "nbpos" lignes et 3 colonnes
	// contenant les positions possibles d'un dé sur le plateau de jeu
	// Correspondant aux coordonnées de la position de chaque dé (x,y) et à son état (libre,occupé)
    var positions = new Array(nbpos);
	
	//1ère Position du dé (en haut à gauche)
    var pos1 = deltaX/2;
    var pos2 = deltaY/2;

function init(){
	// Initialisation des variables
	// Nombre de dés lancés
	$('#nb_des').val(nb_des);
	// Valeur maximum d'une face de dé
	$('#max_points').val(max_points);
	// Initialisation du tableau contenant les coordonnées de la position 
	// de chaque dé (x,y) et à son état (libre,occupé)
	for (var i=0; i<nbpos; i++) {
        positions[i] = [pos1,pos2,0];//0=libre,1=occupé
		pos1 += deltaX;// On décalle vers la droite pour le suivant
		// Si on arrive en bout de ligne (dépassement de la limite du plateau)
		// On passe à la ligne suivante et on revient à pos1 initial
		if (pos1>largeur_jeu-taille_de) {pos1=deltaX/2;pos2 += deltaY};
    }
	// Actions liées aux changements du nombre de dés
	// ou de valeur maximum d'une face
	$('#nb_des').change(function(){
		nb_des=$(this).val();
		});
	$('#max_points').change(function(){
		max_points=$(this).val();
		});
	dessine(nb_des);
}
$(document).ready(function(){
	// Gestion des boutons
	// Bouton Jouer
	// Clic
	$( "#btn_jouer" ).on( "click", function() {
		dessine(nb_des);
	});
	//Survol
	$("#btn_jouer").hover(
		function () {
			$(this).attr('src','images/lancer2.png');  
		},
		function () {
			$(this).attr('src','images/lancer.png');  
		}
	);
	// Bouton Total
	// Clic
	$( "#btn_total" ).on( "click", function() {
		$('#total').css({'display':'block'});
		$('#reponse').text(total);// Ajoute le total à la boîte de dialogue
	});
	//Survol
	$("#btn_total").hover(
		function () {
			$(this).attr('src','images/solution2.png');  
		},
		function () {
			$(this).attr('src','images/solution.png');  
		}
	);
	// Bouton A propos
	// Clic
	$( "#btn_apropos" ).on( "click", function() {
		$('#apropos').css({'display':'block'});
	});
	//Survol
	$("#btn_apropos").hover(
		function () {
			$(this).attr('src','images/aide2.png');  
		},
		function () {
			$(this).attr('src','images/aide.png');  
		}
	);
	// Bouton des boites de dialogue
	//Clic
	$( "#ferme_total" ).on( "click", function() {
		$('#total').css({'display':'none'});
	});
	$( "#ferme_apropos" ).on( "click", function() {
		$('#apropos').css({'display':'none'});
	});
	//Survol
	$("img.quitter").hover(
		function () {
			$(this).attr('src','images/quitter_noir.png');  
		},
		function () {
			$(this).attr('src','images/quitter_gris.png');  
		}
	);
// Initialisation
init();
});


/**
* Copyright :: http://www.ceriously.com/projects/dice/
*/
var c = "";
var debug = false;
var kill = false; //saftey feature to kill script

function dessine_de() {
    if(kill) return;
    dessine_carre(); //Dessin du carré correspondant au dé

    //Dessin du reflet
    c.fillStyle = "rgba(200,200,200,0.4)";
    c.globalAlpha = 1.0;
    c.beginPath();
	var x_reflet=taille_de-5,y_relfet=taille_de-5;
    c.moveTo(-x_reflet,y_relfet);
    c.lineTo(x_reflet,y_relfet);
    c.bezierCurveTo(0, 0, -x_reflet, y_relfet, -x_reflet, -y_relfet); //courbure du reflet
    c.closePath();
    c.fill();

    //Dessin des points
    var n = Math.floor(Math.random()*max_points)+1; //1-max_points points
    c.save();
    c.fillStyle = "black";//Couleur des points
	switch (n) {
	case 1:
		dessine_point(0,0);
		break;
	case 2:
        dessine_point(pointX,pointY);
        dessine_point(-pointX,-pointY);
		break;
	case 3:
        dessine_point(0,0);
        dessine_point(pointX,pointY);
        dessine_point(-pointX,-pointY);
		break;
	case 4:
        dessine_point(pointX,pointY);
        dessine_point(-pointX,-pointY);
        dessine_point(-pointX,pointY);
        dessine_point(pointX,-pointY);
		break;
	case 5:
        dessine_point(0,0);
        dessine_point(pointX,pointY);
        dessine_point(-pointX,-pointY);
        dessine_point(-pointX,pointY);
        dessine_point(pointX,-pointY);
		break;
	case 6:
        dessine_point(pointX,pointY);
        dessine_point(-pointX,-pointY);
        dessine_point(-pointX,pointY);
        dessine_point(pointX,-pointY);
        dessine_point(pointX,0);
        dessine_point(-pointX,0);
		break;
	}
	// On ajoute la valeur du dé à la somme totale
	total+=n;
    c.restore();
}

function dessine_point(x,y) {
    c.beginPath();
    c.arc(x,y,taille_point,0,Math.PI*2,true);
    c.closePath();
    c.fill();
}

function dessine_carre() {
    c.strokeStyle = "#000000";
    c.fillStyle = "rgba(250,250,250,1.0)"; //white
    c.beginPath();
	var w = taille_de;//Taille du dé
    c.moveTo(-w, -w);
    c.lineTo(w,-w);
    c.lineTo(w,w);
    c.lineTo(-w,w);
    c.lineTo(-w,-w);
    c.closePath();
    c.stroke();
    c.fill();
}

function dessine(num) {
    kill = false;
    var canvas = document.getElementById("plateau");
	c = canvas.getContext("2d");
	// Dimensionement du plateau de jeu
	canvas.width=largeur_jeu;
	canvas.height=hauteur_jeu;
	
	// Effacement du plateau de jeu
    c.clearRect(0,0,canvas.width,canvas.height);
	// Initialisation du tableau contenant les coordonnées de la position 
	// de chaque dé (x,y) et à son état (libre,occupé)
	// Toutes les places sont libres au départ
	for (var i=0; i<nbpos; i++) {
        positions[i][2] =0;//0=libre,1=occupé
    }
	total=0;
    //Dessin du nombre de dés
    for (var i=0; i<num; i++) {
	    var counter = 0;
		var j=Math.floor(Math.random()*nbpos);
		// Tant que la position est occupée
		while(positions[j][2]==1) {
            // Choix aléatoire d'une des positions possibles
			// sur le plateau de jeu
			j=Math.floor(Math.random()*nbpos)
            counter++;
            if (counter >= 1000) { //Tue le processus s'il est trop long (évite une boucle infinie)
                alert("Are you trying to crash your browser!? Ceriously...");
                kill = true;
                break;
            }
        }
        if(kill) break;
		// La position est occupée maintenant
		positions[j][2]=1;
		
		// Calcul de l'angle de rotation du dé
		var r = (Math.random()*175) * Math.PI / 180;

        c.save();
        c.translate(positions[j][0], positions[j][1]);// Placement du dé à la position aléatoire
		// Rotation du dé
        c.rotate(r);
        dessine_de();
        c.restore();
    }
}
