/**
 * <pre>
 * Listens to Apropos_COMMAND and displays notifications.
 * Provides interactive tutorial for first time users.
 * </pre>
 *
 * @constructor
 * @param {mindmaps.EventBus} eventBus
 * @param {mindmaps.commandRegistry} commandRegistry
 */
mindmaps.AproposController = function (eventBus, commandRegistry) {
  $( function() {
    $( "#apropos" ).dialog({
      autoOpen: false,
      show: {
        effect: "blind",
        duration: 200
      },
      hide: {
        effect: "explode",
        duration: 200
      }
    });
  } );

    /**
     * Prepares notfications to show for Apropos command.
     */
    function setupAproposButton() {
        var command = commandRegistry.get(mindmaps.aproposCommand);
        command.setHandler(showApropos);

        var notifications = [];

        function showApropos() {
			// alert();
			$( "#apropos" ).dialog( "open" );
        }
    }

    
    setupAproposButton();
};
