//~ ########################
//~ ### INITALISATION
//~ ########################
//~ Initialisation de l'application
function init(){
//~ ########################
//~  ### Boite de dialogue Paramètres
//~ ########################
	$( "#param_dialog" ).dialog({
		autoOpen: false,
		width:"auto"
	});
//~ ########################
//~  ### Boite de dialogue Aide
//~ ########################
	$( "#aide_dialog" ).dialog({
		autoOpen: false,
		width:"auto"
	});
//~ ###########################
//~  ### Bouton Paramètres
//~ ###########################
	$( "#bouton_parametres" ).click(function() {
		$( "#param_dialog" ).dialog( "open" );
	});
//~ ###########################
//~  ### Bouton Aide
//~ ###########################
	$( "#bouton_aide" ).click(function() {
		$( "#aide_dialog" ).dialog( "open" );
	});
//~ ###########################
//~ ### Tous les billets/pièces sont visibles
//~ ###########################
      // Parcours de toutes les checkbox avec la classe "billet"
      $(':checkbox.billet').each(function(){
         $(this).prop('checked',true);
      });
      // Parcours de toutes les checkbox avec la classe "piece"
      $(':checkbox.piece').each(function(){
         $(this).prop('checked',true);
      });	
}
//~ ##############################
//~ ### SAUVEGARDE DU WIDGET
//~ ### EN CAS DE COPIE/CHANEMENT DE PAGE
//~ ##############################
$(function(){
      if (window.widget) {
        // Quand on quitte le widget
	window.widget.onleave = function(){
		// Fermeture des boîtes de dialogues
		$( "#param_dialog" ).dialog( "close" );
		$( "#aide_dialog" ).dialog( "close" );		
		// Sauvegarde de l'état des Cases à cocher est stocké dans un tableau
		// au format 'chaine de caractères'
		var tableau = [];
		// Parcours de toutes les Cases à cocher
		$(':checkbox').each(function(){
			// Insertion de la valeur de la case (cochée=true, décochée=false) dans le tableau
			tableau.push($(this).prop('checked'));
		});
		// Enregistrement de la chaîne de caractères
		window.sankore.setPreference('cases_a_cocher',tableau);
	}
	}
	if(window.sankore){
	// Quand on revient sur le widget, on récupère les paramètres stockés
		if (window.sankore.preference('cases_a_cocher')) {
			// On sépare les mots la chaîne séparés par des virgules
			// et on les place dans un tableau
			var tableau = (window.sankore.preference('cases_a_cocher').split(','));
			// Initialisation de l'Index du tableau
			var cpt=0;
			$(':checkbox').each(function(){
				// Association de la valeur du tableau à l'état de la case à cocher.
				// Correspondance terme à terme entre le tableau et les cases à cocher
				// La valeur du tableau est une chaîne de caractère et doit être convertie en Booléen.
				$(this).prop('checked',(tableau[cpt]=='true'));
				// On passe à l'élément suivant du tableau
				cpt++;
			});
			// On masque ensuite les billets dont la case est décochée
			$(':checkbox.billet').each(function(){
				// On récupère le nom associé à la case à cocher
				var nom='#'+$(this).prop('name');
				// Si la case n'est pas cochée
				if (!$(this).prop('checked')) {
					// On cache le billet
					$(nom).hide();
				}
			});
			// On masque ensuite les pièces dont la case est décochée
			$(':checkbox.piece').each(function(){
				// On récupère le nom associé à la case à cocher
				var nom='#'+$(this).prop('name');
				// Si la case n'est pas cochée
				if (!$(this).prop('checked')) {
					// On cache la pièce
					$(nom).hide();
				}
			});
		} 
    }
	})
//~ ###########################
//~ ### Action quand on clique sur la monnaie
//~ ###########################
$( ".monnaie" ).click(function() {

var x=this.src;//On récupère l'adresse de l'image
x=x.replace(/%7B/,'{');// On remplace les caractères
x=x.replace(/%7D/,'}'); // Pour que l'adressage soit correct
x=x.replace(/%20/,' '); //
sankore.addObject(x,'10%','10%',(-200+cpt*decallage),(-200+cpt*decallage));//On ajoute l'image à la page Sankore
cpt++;//Compteur qui incrémente le nombre de pièces ou de billets pour les afficher décaller.

});
//~ ######################################
//~ ### Action quand on clique sur les miniatures des paramètres
//~ ######################################
$( ".miniature" ).click(function() {
	var nom=this.id.substr(5);//On récupère l'adresse de l'image en enlevant mini_ de l'identifiant -> 5 lettres
	$('input[name='+nom+']').prop('checked',!$('input[name='+nom+']').prop('checked'));
	var x="#"+nom;
	if ($('input[name='+nom+']').prop('checked')) 
		{$(x).show()}
	else
		{$(x).hide()}
});
//~ ###################################
//~ ### Cocher/décocher TOUT
//~ ###################################
//~ La case à cocher de tous les billets
$( ":checkbox#tous_les_billets" ).click(function() {
var drapeau=this.checked;// On récupère la valeur de la case à cocher
	$(':checkbox.billet').prop('checked', drapeau);// On l'affecte à toutes les cases à cocher des billets
	if (drapeau){
	$('.monnaie.billet').show()
	} 
	else {
	$('.monnaie.billet').hide()
	}
});
//~ La vignette de tous les billets
$( "#mini_billets" ).click(function() {
var drapeau=!$(':checkbox#tous_les_billets').prop('checked');// On inverse la valeur de la case à cocher
$(':checkbox#tous_les_billets').prop('checked', drapeau);// On l'affecte à la case à cocher
$(':checkbox.billet').prop('checked', drapeau);// et à toutes les cases à cocher des pièces.
if (drapeau){
	$('.monnaie.billet').show()
	} 
	else {
	$('.monnaie.billet').hide()
	}
});
//~ La case à cocher de toutes les pièces
$( ":checkbox#toutes_les_pieces" ).click(function() {
var drapeau=this.checked;// On récupère la valeur de la case à cocher
	$(':checkbox.piece').prop('checked', drapeau);// On l'affecte à toutes les cases à cocher des pieces
	if (drapeau){
	$('.monnaie.piece').show()
	} 
	else {
	$('.monnaie.piece').hide()
	}
});
//~ La vignette de toutes les pièces
$( "#mini_pieces" ).click(function() {
var drapeau=!$(':checkbox#toutes_les_pieces').prop('checked');// On inverse la valeur de la case à cocher
$(':checkbox#toutes_les_pieces').prop('checked', drapeau);// On l'affecte à la case à cocher
$(':checkbox.piece').prop('checked', drapeau);// et à toutes les cases à cocher des pièces.
if (drapeau){
	$('.monnaie.piece').show()
	} 
	else {
	$('.monnaie.piece').hide()
	}
});

//~ #########################################
//~ ### CASES À COCHER
//~ #########################################
//~ ### Action quand on clique sur les cases à cocher d'un billet
$('input[type="checkbox"].billet' ).change(function() {
var x="#"+this.name;
if (this.checked) 
	{$(x).show()}
	else
	{$(x).hide()}
});
//~ ### Action quand on clique sur les cases à cocher d'une pièce
$('input[type="checkbox"].piece' ).change(function() {
var x="#"+this.name;
if (this.checked) 
	{$(x).show()}
	else
	{$(x).hide()}
});
