var	damier = new Array, // Tableau conservant les couleurs des cases
	lbl=new Array,//Etiquettes
	X_canvas=800,Y_canvas=400,// Dimensions maximales du Canvas
	papier = Raphael("grille","100%","100%"),// Occupe tout le div
	x0 = 10,// Abscisse de démarrage du grille (gauche) et marge autour du dessin
        y0 = 10,// Ordonnée de démarrage du Canvas (haut) et marge autour du dessin
        dx0 = 50,dx=dx0, // Largeur d'une case: dx0 largeur initiale non modifiable, dx largeur en cours, modifiable
        dy0 = 50,dy=dy0, // Hauteur d'une case : idem
	dxmin=dx0,dymin=dx0,dxmax=X_canvas, dymax=Y_canvas, // Dimensions minimales/maximales d'une case
	dxstep=dx0,dystep=dy0,// PAS d'augmentation en hauteur et largeur des cases
	mode,mode_defaut='edition',//Mode d'affichage
	lignes=1,colonnes=1, // Dimensions initiales du quadrillage
	// Couleurs de la palette
	palette_base=[noir="000000",gris="A9A9A9",rouge="FF0000",orange="FFA500",marron="CD853F",jaune="FFFF00",vert_clair="98FB98", vert_fonce="32CD32",bleu_clair="ADD8E6",bleu_fonce="0000FF",rose="FF00FF",violet="BA55D3"],
	blanc="FFFFFF",couleur_defaut="#"+blanc,couleur_fraction="#"+rouge, couleur_ligne="#"+noir;
	//Couleur par défaut (vide), de la fraction et des lignes du quadrillage 
	blanc="FFFFFF",couleur_defaut="#"+blanc,couleur_fraction="#"+rouge, couleur_ligne="#"+noir;

// #####################################
// ##### INITIALISATION DE LA GRILLE
// #####################################
function init_damier(nb_lignes,nb_colonnes) {
// Initialisation de la grille
for (var k=0; k < nb_lignes; k++){
			for (var l=0;l<nb_colonnes;l++){
				damier[k+','+l]=(false);
			}
	}
}
// #####################################
// ##### INITIALISATION DE LA PALETTE
// #####################################
function init_palette() {
//Initialisation des palettes de couleurs
	// Palette pour les cases
	$('#color1').colorPicker({pickerDefault: couleur_fraction, colors: palette_base, showHexField: false, onColorChange : function(id, newValue) { couleur_fraction=newValue;quadrillage(lignes, colonnes);}});
	// Palette pour les lignes
	$('#color2').colorPicker({pickerDefault: couleur_ligne, colors: palette_base, showHexField: false, onColorChange : function(id, newValue) { couleur_ligne=newValue;quadrillage(lignes, colonnes);}});
}
// #####################################
// ##### MODIFICATION DE LA COULEUR
// #####################################
function couleur(couleur_part) {
	if (couleur_part) {return couleur_fraction;} else {return couleur_defaut;};
}

// #####################################
// ##### AFFICHAGE / MASQUAGE DES ETIQUETTES
// #####################################
function affiche_etiquettes() {
// Affichage de l'étiquette sous la forme a/b)
	var nb_parts=lignes*colonnes;
	if (document.getElementById("etiquettes").checked) {
		if (nb_parts==1) {
			lbl["1 1a"].show();
			lbl["1 1b"].show();
		}
		else {
			for	(var k=0; k < lignes; k++){ // Boucle sur le nombre de lignes
				for (var l=0;l<colonnes;l++){ // Boucle sur le nombre de colonnes
					lbl[k+' '+l+"a"].show();lbl[k+' '+l+"-"].show();lbl[k+' '+l+"b"].show();
				}
			}
		}
	}
	else  {
		if (nb_parts==1) {
			lbl["1 1a"].hide();
			lbl["1 1b"].hide();
		} 
		else{
			for	(var k=0; k < lignes; k++){ // Boucle sur le nombre de lignes
				for (var l=0;l<colonnes;l++){ // Boucle sur le nombre de colonnes
					lbl[k+' '+l+"a"].hide();lbl[k+' '+l+"-"].hide();lbl[k+' '+l+"b"].hide();
				}
			}
		}
	}
}
// #####################################
// ##### INITIALISATION
// #####################################
function init() {
init_damier (ligne_max(), colonne_max()); // initialise les couleurs des cases
	if (window.widget) {
        // Quand on quitte le widget
		window.widget.onleave = function(){	
		//Sauvegarde des paramètres au format 'chaine de caractères'
		window.sankore.setPreference('Lignes', lignes);
		window.sankore.setPreference('Colonnes', colonnes);
		window.sankore.setPreference('Couleur fraction', couleur_fraction);
		window.sankore.setPreference('Couleur ligne', couleur_ligne);
		window.sankore.setPreference('Largeur case', dx);
		window.sankore.setPreference('Longueur case', dy);
		window.sankore.setPreference('Etiquettes',document.getElementById("etiquettes").checked);//Affichage des étiquettes
		window.sankore.setPreference('mode', mode);
		// Références des cases coloriées		
		for	(var k=0; k < lignes; k++){ // Boucle sur le nombre de lignes
			for (var l=0;l<colonnes;l++){ // Boucle sur le nombre de colonnes
				window.sankore.setPreference((k+','+l),damier[k+','+l]);// Couleur de la case
			}
		}
		}
	}
	
	if(window.sankore){
	// Quand on revient sur le widget, on récupère les paramètres stockés
		if (window.sankore.preference('Lignes')) {
		lignes=parseInt(window.sankore.preference('Lignes'));
		colonnes=parseInt(window.sankore.preference('Colonnes'));
		couleur_fraction=window.sankore.preference('Couleur fraction');
		couleur_ligne=window.sankore.preference('Couleur ligne');
		dx=parseInt(window.sankore.preference('Largeur case'));
		dy=parseInt(window.sankore.preference('Longueur case'));
		document.getElementById("etiquettes").checked=JSON.parse(window.sankore.preference('Etiquettes'));//Valeur logique stockée sous forme de chaîne, donc à convertir en boolean
		mode=window.sankore.preference('mode');
		// Références des cases coloriées
		for	(var k=0; k < lignes; k++){ // Boucle sur le nombre de lignes
			for (var l=0;l<colonnes;l++){ // Boucle sur le nombre de colonnes
				(damier[k+','+l])=JSON.parse(window.sankore.preference((k+','+l)));// Couleur de la case , Valeur logique stockée sous forme de chaîne, donc à convertir en boolean
			}
		}
		} 
	}
	document.getElementById("nb colonnes").value=colonnes; //Mise à jour du curseur COLONNES
	document.getElementById("nb colonnes").min=1; 
	document.getElementById("nb colonnes").max=colonne_max(); 
	document.getElementById("nb colonnes").step=1; 
	document.getElementById("nb lignes").value=lignes; //Mise à jour du curseur LIGNES
	document.getElementById("nb lignes").min=1; 
	document.getElementById("nb lignes").max=ligne_max(); 
	document.getElementById("nb lignes").step=1; 
	document.getElementById("hauteur case").min=dymin;//Mise à jour du curseur HAUTEUR DE CASE
	document.getElementById("hauteur case").max=dymax;
	document.getElementById("hauteur case").step=dystep;
	document.getElementById("hauteur case").value=dy; 
	document.getElementById("largeur case").min=dxmin;//Mise à jour du curseur LARGEUR DE CASE
	document.getElementById("largeur case").max=dxmax;
	document.getElementById("largeur case").step=dxstep;
	document.getElementById("largeur case").value=dx; 
    if ( undefined ==mode) {mode=mode_defaut};//Mode d'affichage par défaut si la variable est vide (1er passage/chargement)
    mode_affichage(mode);// Mode d'affichage
	$("#color1").val(couleur_fraction).change();// Adaptation du colorpicker
	$("#color2").val(couleur_ligne).change();// Adaptation du colorpicker
//Trace le quadrillage(lignes x colonnes)
quadrillage(lignes, colonnes);
}

// #####################################
// ##### MODE AFFICHAGE
// #####################################
function mode_affichage(style_affichage){
	mode=style_affichage;
	// ##################
	// ##### MODE VUE #####
	// ##################
	if (mode=="vue") {
		// On cache les réglages
		$("#reglages").hide();
		adapte_canvas("grille",dx*colonnes+x0*2,dy*lignes+y0*2);
		var widgetX=$("#grille").width(),widgetY=$("#grille").height();
		redimensionne(widgetX,widgetY);
	};
	// #####################
	// ##### MODE EDITION #####
	// ####################
	if (mode=="edition") {
		// On affiche les réglages
		$("#reglages").show();
		adapte_canvas("grille",X_canvas,Y_canvas);
		var widgetX=Math.max($("#grille").width(),$("#reglages").width()),widgetY=($("#grille").height()+$("#reglages").height());
		redimensionne(widgetX+25,widgetY+25);
	};
}

// #####################################
// ##### ADAPTATION DU CANVAS
// #####################################
function adapte_canvas(id,largeur,hauteur) {
//Adaptation de la hauteur et largeur du canvas
var elem=document.getElementById(id);
	elem.style.width = largeur+"px";
	elem.style.height = hauteur+"px";
}
// #####################################
// ##### REDIMENSIONNEMENT DE LA FENETRE
// #####################################
function redimensionne(largeur,longueur) {
// Redimensionne le widget sankore
var margex=25,margey=25; // épaisseur de la fenêtre sankore
window.sankore.resize(largeur+margex,longueur+margey);
}
// #####################################
// ##### TRAÇAGE DU QUADRILLAGE
// #####################################
function quadrillage(nb_lignes,nb_colonnes) {
	var nb_parts=nb_lignes*nb_colonnes;
	papier.clear(); // Efface le dessin précédent
	x=x0;// Coordonnées de démarrage du dessin
	y=y0;
	if (nb_parts==1) {
		var p=papier.rect(x,y,dx,dy);// Définition du rectangle
		p.attr({stroke:couleur_ligne, fill: couleur(damier['1,1']),cursor:"pointer"});// Couleur du contour, de la case et apparence du curseur
		p.data("coord", ('1,1')); // Sauvegarde des coordonnées de la case
		p.click(function() { // Gestion du clic sur la grille
			damier[this.data("coord")]=!damier[this.data("coord")];// Inversion de la couleur
			this.attr({fill:couleur(damier[this.data("coord")])});// On attribut la couleur à la case
		});
		lbl["1 1a"] = papier.text(x+dx/2 , y+dy/2-10,"1").attr({fill: "black", stroke: "none", opacity: 1, "font-style": "underline", "font-size": 20}).hide(); 
		lbl["1 1b"] = papier.text(x+dx/2 , y+dy/2+10,"unité").attr({fill: "black", stroke: "none", opacity: 1, "font-style": "underline", "font-size": 20}).hide();
	}
	else {
    for	(var k=0; k < nb_lignes; k++){ // Boucle sur le nombre de lignes
		for (var l=0;l<nb_colonnes;l++){ // Boucle sur le nombre de colonnes
			var p=papier.rect(x,y,dx,dy);// Définition du rectangle
			p.attr({stroke:couleur_ligne, fill: couleur(damier[k+','+l]),cursor:"pointer"});// Couleur du contour, de la case et apparence du curseur
			p.data("coord", (k+','+l)); // Sauvegarde des coordonnées de la case
			p.click(function() { // Gestion du clic sur la grille
				damier[this.data("coord")]=!damier[this.data("coord")];// Inversion de la couleur
				this.attr({fill:couleur(damier[this.data("coord")])});// On attribut la couleur à la case
			});
			lbl[k+' '+l+"a"] = papier.text(x+dx/2 , y+dy/2-10 ,"1").attr({fill: "black", stroke: "none", opacity: 1, "font-style": "underline", "font-size": 20}).hide();// Ecriture du numérateur
			lbl[k+' '+l+"-"] = papier.path( ["M", x+dx/2-10 , y+dy/2, "L", x+dx/2+10, y+dy/2] ).hide();// Tracé de la barre de fraction
			lbl[k+' '+l+"b"] = papier.text(x+dx/2 , y+dy/2+10,nb_parts).attr({fill: "black", stroke: "none", opacity: 1, "font-size": 20}).hide();// Ecriture du dénominateur
			x+=dx;// On passe à la colonne suivante
		}
		x=x0;// On revient à la marge
		y+=dy;// On passe à la ligne suivante
	}
}
	affiche_etiquettes(); // Affiche ou non les étiquettes (valeurs) sur les fractions en fonction de la Checkbox
}
// ##################################################
// ##### FONCTION CALCULANT LE NOMBRE MAXIMAL DE COLONNES
// ##################################################
function colonne_max() {
var dimension=parseInt((X_canvas-y0*2)/dx);
return dimension;
}
// ##################################################
// ##### FONCTION CALCULANT LE NOMBRE MAXIMAL DE LIGNES
// ##################################################
function ligne_max() {
var dimension=parseInt((Y_canvas-y0*2)/dy);
return dimension;
}
// ##################################################
// ##### FONCTION CALCULANT LA HAUTEUR D'UNE CASE
// ##################################################
function hauteur_case(taille) {
// taille>0 -> augmentation ; taille<0 -> diminution
	dy+=taille;
	if ((dy<dymin)||(dy>dymax)||(Y_canvas<(dy*lignes+y0*2))) {dy-=taille};//Pas de changement si dépassement de limites
	document.getElementById("hauteur case").value=dy; //Mise à jour du curseur
	quadrillage(lignes, colonnes);
}
// ##################################################
// ##### FONCTION CALCULANT LA LARGEUR D'UNE CASE
// ##################################################
function largeur_case(taille) {
// taille>0 -> augmentation ; taille<0 -> diminution
	dx+=taille;
	if ((dx<dxmin)||(dx>dxmax)||(X_canvas<(dx*colonnes+x0*2))) {dx-=taille};//Pas de changement si dépassement de limites
	document.getElementById("largeur case").value=dx; //Mise à jour du curseur
	quadrillage(lignes, colonnes);
}
// ########################################
// ##### AJOUTE OU ENLEVE UNE COLONNE DE LA GRILLE
// ########################################
function ajoute_colonnes(nombre) {
//nombre>0 -> On ajoute 'nombre' colonnes ; nb<0 on elève 'nombre' colonnes
	colonnes+=nombre;
	if ((colonnes<1)||(colonnes>colonne_max())) {colonnes-=nombre};//Pas de changement si dépassement de limites
	document.getElementById("nb colonnes").value=colonnes; //Mise à jour du curseur LIGNES
	quadrillage(lignes, colonnes);
}
// #####################################
// ##### AJOUTE OU ENLEVE UNE LIGNE DE LA GRILLE
// #####################################
function ajoute_lignes(nombre) {
//nombre>0 -> On ajoute 'nombre' lignes ; nb<0 on elève 'nombre' lignes
	lignes+=nombre;
	if ((lignes<1)||(lignes>ligne_max())) {lignes-=nombre};//Pas de changement si dépassement de limites
	document.getElementById("nb lignes").value=lignes; //Mise à jour du curseur LIGNES
	quadrillage(lignes, colonnes);
}